package pps.core.base.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import xstartup.annotation.XText;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

@Data
@TableName("base_photovoltaic_plant")
public class BasePhotovoltaicPlantEnt implements Serializable {
    @XText("ID")
    @TableId(type = IdType.ASSIGN_UUID)
    private String id;

    @XText("是否删除(0_是;1_否)")
    @TableField
    private Integer isDeleted;

    @XText("创建人ID")
    @TableField
    private String createById;

    @XText("创建人名称")
    @TableField
    private String createByName;

    @XText("创建时间")
    @TableField
    private Date createTime;

    @XText("修改人ID")
    @TableField
    private String modifyById;

    @XText("修改人名称")
    @TableField
    private String modifyByName;

    @XText("修改时间")
    @TableField
    private Date modifyTime;

    @XText("组织机构ID")
    @TableField
    private String ouId;

    @XText("电站名称")
    @TableField
    private String stationName;

    @XText("出厂编号")
    @TableField
    private String makerNumber;

    @XText("光伏设备规格型号key(字典获取)")
    @TableField
    private String photovoltaicModelKey;

    @XText("安装倾角")
    @TableField
    private BigDecimal mountingAngle;

    @XText("装机总量(KWP)")
    @TableField
    private BigDecimal totalPower;

    @XText("阵列朝向")
    @TableField
    private BigDecimal arrayOrientation;

    @XText("组织机构name")
    @TableField
    private String ouName;
    @XText("光伏设备规格型号name(字典获取)")
    @TableField
    private String photovoltaicModelName;
}
