package pps.core.base.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import xstartup.annotation.XText;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 输电线路井口配置
 *
 * @author ZWT
 * @date 2023/08/25
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class BasePowerLineWellheadView implements Serializable {
    @XText("ID")
    @TableField
    private String id;

    @XText("是否删除(0_是;1_否)")
    @TableField
    private Integer isDeleted;

    @XText("创建人ID")
    @TableField
    private String createById;

    @XText("创建人名称")
    @TableField
    private String createByName;

    @XText("创建时间")
    @TableField
    private Date createTime;

    @XText("修改人ID")
    @TableField
    private String modifyById;

    @XText("修改人名称")
    @TableField
    private String modifyByName;

    @XText("修改时间")
    @TableField
    private Date modifyTime;

    @XText("线路ID")
    @TableField
    private String lineId;

    @XText("井口ID")
    @TableField
    private String wellheadId;

    @XText("组织机构ID")
    @TableField
    private String ouId;

    @XText("启动顺序")
    @TableField
    private Integer startSeq;

    /**
     * 井号
     */
    @XText("井号")
    @TableField
    private String wellNumber;

    /**
     * 运行类型
     */
    @XText("运行类型key(字典获取)")
    private String runTypeKey;

    /**
     * 运行功率
     */
    @XText("运行功率(KW)")
    @TableField
    private BigDecimal serviceRating;
}
