package pps.core.base.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import jakarta.validation.Valid;
import lombok.Data;
import pps.core.common.entity.BaseModel;
import xstartup.annotation.XText;

import java.io.Serializable;
import java.util.List;

/**
 * 市电峰谷月配置表
 *
 * @author ZWT
 * @date 2023/08/24
 */
@Data
@TableName("base_price_strategy_month")
public class BasePriceStrategyMonthEnt extends BaseModel implements Serializable {

    @XText("市电峰谷配置ID")
    @TableField
    private String strategyId;

    @XText("市电峰谷月(1-12)")
    @TableField
    private String strategyMonth;

    /**
     * 策略明细入参
     */
    @TableField(exist = false)
    @Valid
    private List<BasePriceStrategyDetailEnt> details;
}
