package pps.core.base.service;

import pps.cloud.system.service.SysOrganizationCloudService;
import pps.cloud.system.service.data.GetAllOuListByOuIdInput;
import pps.cloud.system.service.data.GetSysOrganizationViewOutput;
import xstartup.base.XContext;
import xstartup.data.XListResult;

import java.util.List;
import java.util.stream.Collectors;

/**
 * @Description
 * @Author luoxiangyang
 * @Date 2023/8/31 14:13
 **/
public class BaseService {
    /**
     * 根据ouid获取所有子集的ouid
     * @param context
     * @param ouId
     * @return
     */
    public  List<String> getAllListByOuId(XContext context,String ouId){
        SysOrganizationCloudService organizationCloudService = context.getBean(SysOrganizationCloudService.class);
        GetAllOuListByOuIdInput ouIdInput=new GetAllOuListByOuIdInput();
        ouIdInput.setOuId(ouId);
        XListResult<GetSysOrganizationViewOutput> allListByOuId = organizationCloudService.getAllListByOuId(context, ouIdInput);
        allListByOuId.throwIfFail();
        List<GetSysOrganizationViewOutput> listByOuIdResult = allListByOuId.getResult();
        return listByOuIdResult.stream().map(GetSysOrganizationViewOutput::getId).collect(Collectors.toList());
    }
}
