package pps.core.space.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.space.entity.SpaceOptimizeLongDurationEnt;
import pps.core.space.entity.SpaceOptimizeLongDurationView;
import pps.core.space.mapper.SpaceOptimizeLongDurationMapper;
import pps.core.space.mapper.SpaceOptimizeLongDurationViewMapper;
import pps.core.space.service.data.space_optimize_long_duration.*;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.data.CustomQueryInput;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class SpaceOptimizeLongDurationService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createSpaceOptimizeLongDuration(XContext context, CreateSpaceOptimizeLongDurationInput input) {
        SpaceOptimizeLongDurationMapper mapper = context.getBean(SpaceOptimizeLongDurationMapper.class);
        SpaceOptimizeLongDurationEnt entity = new SpaceOptimizeLongDurationEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateSpaceOptimizeLongDuration(XContext context, UpdateSpaceOptimizeLongDurationInput input) {
        SpaceOptimizeLongDurationMapper mapper = context.getBean(SpaceOptimizeLongDurationMapper.class);
        QueryWrapper<SpaceOptimizeLongDurationEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeLongDurationEnt::getId, input.getId());
        SpaceOptimizeLongDurationEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteSpaceOptimizeLongDuration(XContext context, DeleteSpaceOptimizeLongDurationInput input) {
        SpaceOptimizeLongDurationMapper mapper = context.getBean(SpaceOptimizeLongDurationMapper.class);
        QueryWrapper<SpaceOptimizeLongDurationEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeLongDurationEnt::getId, input.getId());
        SpaceOptimizeLongDurationEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceOptimizeLongDurationOutput> getSpaceOptimizeLongDuration(XContext context, GetSpaceOptimizeLongDurationInput input) {
        SpaceOptimizeLongDurationMapper mapper = context.getBean(SpaceOptimizeLongDurationMapper.class);
        QueryWrapper<SpaceOptimizeLongDurationEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeLongDurationEnt::getId, input.getId());
        SpaceOptimizeLongDurationEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceOptimizeLongDurationOutput output = new GetSpaceOptimizeLongDurationOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeLongDurationOutput> querySpaceOptimizeLongDuration(XContext context, QuerySpaceOptimizeLongDurationInput input) {
        SpaceOptimizeLongDurationMapper mapper = context.getBean(SpaceOptimizeLongDurationMapper.class);
        QueryWrapper<SpaceOptimizeLongDurationEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(SpaceOptimizeLongDurationEnt::getId, input.getId())
                .eq(SpaceOptimizeLongDurationEnt::getIsDeleted, input.getIsDeleted())
                .like(SpaceOptimizeLongDurationEnt::getCreateById, input.getCreateById())
                .like(SpaceOptimizeLongDurationEnt::getCreateByName, input.getCreateByName())
                .eq(SpaceOptimizeLongDurationEnt::getCreateTime, input.getCreateTime())
                .like(SpaceOptimizeLongDurationEnt::getModifyById, input.getModifyById())
                .like(SpaceOptimizeLongDurationEnt::getModifyByName, input.getModifyByName())
                .eq(SpaceOptimizeLongDurationEnt::getModifyTime, input.getModifyTime())
                .like(SpaceOptimizeLongDurationEnt::getRecordId, input.getRecordId())
                .like(SpaceOptimizeLongDurationEnt::getLongPeriodId, input.getLongPeriodId())
                .like(SpaceOptimizeLongDurationEnt::getWellheadId, input.getWellheadId())
                .eq(SpaceOptimizeLongDurationEnt::getIsOptimize, input.getIsOptimize())
                .like(SpaceOptimizeLongDurationEnt::getGenerationTypeKey, input.getGenerationTypeKey())
                .like(SpaceOptimizeLongDurationEnt::getOpenWellTime, input.getOpenWellTime())
                .like(SpaceOptimizeLongDurationEnt::getCloseWellTime, input.getCloseWellTime());
        return XMapperHelper.query(mapper, input, queryWrapper, QuerySpaceOptimizeLongDurationOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeLongDurationOutput> dynamicQuerySpaceOptimizeLongDuration(XContext context, CustomQueryInput input) {
        SpaceOptimizeLongDurationMapper mapper = context.getBean(SpaceOptimizeLongDurationMapper.class);
        return XMapperHelper.query(mapper, input, SpaceOptimizeLongDurationEnt.class, QuerySpaceOptimizeLongDurationOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceOptimizeLongDurationViewOutput> getSpaceOptimizeLongDurationView(XContext context, GetSpaceOptimizeLongDurationViewInput input) {
        SpaceOptimizeLongDurationViewMapper mapper = context.getBean(SpaceOptimizeLongDurationViewMapper.class);
        SpaceOptimizeLongDurationView record = new SpaceOptimizeLongDurationView();
        XCopyUtils.copyObject(input, record);
        SpaceOptimizeLongDurationView view = mapper.selectOne(record);
        if (view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceOptimizeLongDurationViewOutput output = new GetSpaceOptimizeLongDurationViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeLongDurationViewOutput> querySpaceOptimizeLongDurationView(XContext context, QuerySpaceOptimizeLongDurationViewInput input) {
        SpaceOptimizeLongDurationViewMapper mapper = context.getBean(SpaceOptimizeLongDurationViewMapper.class);
        SpaceOptimizeLongDurationView record = new SpaceOptimizeLongDurationView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<SpaceOptimizeLongDurationView> list = mapper.selectList(record);
        PageInfo<SpaceOptimizeLongDurationView> pageInfo = new PageInfo<>(list);
        List<QuerySpaceOptimizeLongDurationViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QuerySpaceOptimizeLongDurationViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
