package pps.core.space.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.space.entity.SpaceOptimizeLongPeriodEnt;
import pps.core.space.entity.SpaceOptimizeLongPeriodView;
import pps.core.space.mapper.SpaceOptimizeLongPeriodMapper;
import pps.core.space.mapper.SpaceOptimizeLongPeriodViewMapper;
import pps.core.space.service.data.space_optimize_long_period.*;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.data.CustomQueryInput;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class SpaceOptimizeLongPeriodService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createSpaceOptimizeLongPeriod(XContext context, CreateSpaceOptimizeLongPeriodInput input) {
        SpaceOptimizeLongPeriodMapper mapper = context.getBean(SpaceOptimizeLongPeriodMapper.class);
        SpaceOptimizeLongPeriodEnt entity = new SpaceOptimizeLongPeriodEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateSpaceOptimizeLongPeriod(XContext context, UpdateSpaceOptimizeLongPeriodInput input) {
        SpaceOptimizeLongPeriodMapper mapper = context.getBean(SpaceOptimizeLongPeriodMapper.class);
        QueryWrapper<SpaceOptimizeLongPeriodEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeLongPeriodEnt::getId, input.getId());
        SpaceOptimizeLongPeriodEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteSpaceOptimizeLongPeriod(XContext context, DeleteSpaceOptimizeLongPeriodInput input) {
        SpaceOptimizeLongPeriodMapper mapper = context.getBean(SpaceOptimizeLongPeriodMapper.class);
        QueryWrapper<SpaceOptimizeLongPeriodEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeLongPeriodEnt::getId, input.getId());
        SpaceOptimizeLongPeriodEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceOptimizeLongPeriodOutput> getSpaceOptimizeLongPeriod(XContext context, GetSpaceOptimizeLongPeriodInput input) {
        SpaceOptimizeLongPeriodMapper mapper = context.getBean(SpaceOptimizeLongPeriodMapper.class);
        QueryWrapper<SpaceOptimizeLongPeriodEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeLongPeriodEnt::getId, input.getId());
        SpaceOptimizeLongPeriodEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceOptimizeLongPeriodOutput output = new GetSpaceOptimizeLongPeriodOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeLongPeriodOutput> querySpaceOptimizeLongPeriod(XContext context, QuerySpaceOptimizeLongPeriodInput input) {
        SpaceOptimizeLongPeriodMapper mapper = context.getBean(SpaceOptimizeLongPeriodMapper.class);
        QueryWrapper<SpaceOptimizeLongPeriodEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(SpaceOptimizeLongPeriodEnt::getId, input.getId())
                .eq(SpaceOptimizeLongPeriodEnt::getIsDeleted, input.getIsDeleted())
                .like(SpaceOptimizeLongPeriodEnt::getCreateById, input.getCreateById())
                .like(SpaceOptimizeLongPeriodEnt::getCreateByName, input.getCreateByName())
                .eq(SpaceOptimizeLongPeriodEnt::getCreateTime, input.getCreateTime())
                .like(SpaceOptimizeLongPeriodEnt::getModifyById, input.getModifyById())
                .like(SpaceOptimizeLongPeriodEnt::getModifyByName, input.getModifyByName())
                .eq(SpaceOptimizeLongPeriodEnt::getModifyTime, input.getModifyTime())
                .like(SpaceOptimizeLongPeriodEnt::getLineId, input.getLineId())
                .like(SpaceOptimizeLongPeriodEnt::getInstitutionId, input.getInstitutionId())
                .like(SpaceOptimizeLongPeriodEnt::getExecutionCycle, input.getExecutionCycle())
                .eq(SpaceOptimizeLongPeriodEnt::getOptimizeState, input.getOptimizeState())
                .eq(SpaceOptimizeLongPeriodEnt::getOptimizeDeadline, input.getOptimizeDeadline());
        return XMapperHelper.query(mapper, input, queryWrapper, QuerySpaceOptimizeLongPeriodOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeLongPeriodOutput> dynamicQuerySpaceOptimizeLongPeriod(XContext context, CustomQueryInput input) {
        SpaceOptimizeLongPeriodMapper mapper = context.getBean(SpaceOptimizeLongPeriodMapper.class);
        return XMapperHelper.query(mapper, input, SpaceOptimizeLongPeriodEnt.class, QuerySpaceOptimizeLongPeriodOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceOptimizeLongPeriodViewOutput> getSpaceOptimizeLongPeriodView(XContext context, GetSpaceOptimizeLongPeriodViewInput input) {
        SpaceOptimizeLongPeriodViewMapper mapper = context.getBean(SpaceOptimizeLongPeriodViewMapper.class);
        SpaceOptimizeLongPeriodView record = new SpaceOptimizeLongPeriodView();
        XCopyUtils.copyObject(input, record);
        SpaceOptimizeLongPeriodView view = mapper.selectOne(record);
        if (view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceOptimizeLongPeriodViewOutput output = new GetSpaceOptimizeLongPeriodViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeLongPeriodViewOutput> querySpaceOptimizeLongPeriodView(XContext context, QuerySpaceOptimizeLongPeriodViewInput input) {
        SpaceOptimizeLongPeriodViewMapper mapper = context.getBean(SpaceOptimizeLongPeriodViewMapper.class);
        SpaceOptimizeLongPeriodView record = new SpaceOptimizeLongPeriodView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<SpaceOptimizeLongPeriodView> list = mapper.selectList(record);
        PageInfo<SpaceOptimizeLongPeriodView> pageInfo = new PageInfo<>(list);
        List<QuerySpaceOptimizeLongPeriodViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QuerySpaceOptimizeLongPeriodViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
