package pps.core.space.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.space.entity.SpaceOptimizeMidPeriodEnt;
import pps.core.space.entity.SpaceOptimizeMidPeriodView;
import pps.core.space.mapper.SpaceOptimizeMidPeriodMapper;
import pps.core.space.mapper.SpaceOptimizeMidPeriodViewMapper;
import pps.core.space.service.data.space_optimize_mid_period.*;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.data.CustomQueryInput;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class SpaceOptimizeMidPeriodService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createSpaceOptimizeMidPeriod(XContext context, CreateSpaceOptimizeMidPeriodInput input) {
        SpaceOptimizeMidPeriodMapper mapper = context.getBean(SpaceOptimizeMidPeriodMapper.class);
        SpaceOptimizeMidPeriodEnt entity = new SpaceOptimizeMidPeriodEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateSpaceOptimizeMidPeriod(XContext context, UpdateSpaceOptimizeMidPeriodInput input) {
        SpaceOptimizeMidPeriodMapper mapper = context.getBean(SpaceOptimizeMidPeriodMapper.class);
        QueryWrapper<SpaceOptimizeMidPeriodEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeMidPeriodEnt::getId, input.getId());
        SpaceOptimizeMidPeriodEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteSpaceOptimizeMidPeriod(XContext context, DeleteSpaceOptimizeMidPeriodInput input) {
        SpaceOptimizeMidPeriodMapper mapper = context.getBean(SpaceOptimizeMidPeriodMapper.class);
        QueryWrapper<SpaceOptimizeMidPeriodEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeMidPeriodEnt::getId, input.getId());
        SpaceOptimizeMidPeriodEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceOptimizeMidPeriodOutput> getSpaceOptimizeMidPeriod(XContext context, GetSpaceOptimizeMidPeriodInput input) {
        SpaceOptimizeMidPeriodMapper mapper = context.getBean(SpaceOptimizeMidPeriodMapper.class);
        QueryWrapper<SpaceOptimizeMidPeriodEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeMidPeriodEnt::getId, input.getId());
        SpaceOptimizeMidPeriodEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceOptimizeMidPeriodOutput output = new GetSpaceOptimizeMidPeriodOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeMidPeriodOutput> querySpaceOptimizeMidPeriod(XContext context, QuerySpaceOptimizeMidPeriodInput input) {
        SpaceOptimizeMidPeriodMapper mapper = context.getBean(SpaceOptimizeMidPeriodMapper.class);
        QueryWrapper<SpaceOptimizeMidPeriodEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(SpaceOptimizeMidPeriodEnt::getId, input.getId())
                .eq(SpaceOptimizeMidPeriodEnt::getIsDeleted, input.getIsDeleted())
                .like(SpaceOptimizeMidPeriodEnt::getCreateById, input.getCreateById())
                .like(SpaceOptimizeMidPeriodEnt::getCreateByName, input.getCreateByName())
                .eq(SpaceOptimizeMidPeriodEnt::getCreateTime, input.getCreateTime())
                .like(SpaceOptimizeMidPeriodEnt::getModifyById, input.getModifyById())
                .like(SpaceOptimizeMidPeriodEnt::getModifyByName, input.getModifyByName())
                .eq(SpaceOptimizeMidPeriodEnt::getModifyTime, input.getModifyTime())
                .like(SpaceOptimizeMidPeriodEnt::getLineId, input.getLineId())
                .like(SpaceOptimizeMidPeriodEnt::getInstitutionId, input.getInstitutionId())
                .like(SpaceOptimizeMidPeriodEnt::getExecutionCycle, input.getExecutionCycle())
                .eq(SpaceOptimizeMidPeriodEnt::getOptimizeState, input.getOptimizeState())
                .eq(SpaceOptimizeMidPeriodEnt::getOptimizeDeadline, input.getOptimizeDeadline());
        return XMapperHelper.query(mapper, input, queryWrapper, QuerySpaceOptimizeMidPeriodOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeMidPeriodOutput> dynamicQuerySpaceOptimizeMidPeriod(XContext context, CustomQueryInput input) {
        SpaceOptimizeMidPeriodMapper mapper = context.getBean(SpaceOptimizeMidPeriodMapper.class);
        return XMapperHelper.query(mapper, input, SpaceOptimizeMidPeriodEnt.class, QuerySpaceOptimizeMidPeriodOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceOptimizeMidPeriodViewOutput> getSpaceOptimizeMidPeriodView(XContext context, GetSpaceOptimizeMidPeriodViewInput input) {
        SpaceOptimizeMidPeriodViewMapper mapper = context.getBean(SpaceOptimizeMidPeriodViewMapper.class);
        SpaceOptimizeMidPeriodView record = new SpaceOptimizeMidPeriodView();
        XCopyUtils.copyObject(input, record);
        SpaceOptimizeMidPeriodView view = mapper.selectOne(record);
        if (view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceOptimizeMidPeriodViewOutput output = new GetSpaceOptimizeMidPeriodViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeMidPeriodViewOutput> querySpaceOptimizeMidPeriodView(XContext context, QuerySpaceOptimizeMidPeriodViewInput input) {
        SpaceOptimizeMidPeriodViewMapper mapper = context.getBean(SpaceOptimizeMidPeriodViewMapper.class);
        SpaceOptimizeMidPeriodView record = new SpaceOptimizeMidPeriodView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<SpaceOptimizeMidPeriodView> list = mapper.selectList(record);
        PageInfo<SpaceOptimizeMidPeriodView> pageInfo = new PageInfo<>(list);
        List<QuerySpaceOptimizeMidPeriodViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QuerySpaceOptimizeMidPeriodViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
