package pps.core.space.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.space.entity.SpaceOptimizeMidWellheadEnt;
import pps.core.space.entity.SpaceOptimizeMidWellheadView;
import pps.core.space.mapper.SpaceOptimizeMidWellheadMapper;
import pps.core.space.mapper.SpaceOptimizeMidWellheadViewMapper;
import pps.core.space.service.data.space_optimize_mid_wellhead.*;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.data.CustomQueryInput;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class SpaceOptimizeMidWellheadService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createSpaceOptimizeMidWellhead(XContext context, CreateSpaceOptimizeMidWellheadInput input) {
        SpaceOptimizeMidWellheadMapper mapper = context.getBean(SpaceOptimizeMidWellheadMapper.class);
        SpaceOptimizeMidWellheadEnt entity = new SpaceOptimizeMidWellheadEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateSpaceOptimizeMidWellhead(XContext context, UpdateSpaceOptimizeMidWellheadInput input) {
        SpaceOptimizeMidWellheadMapper mapper = context.getBean(SpaceOptimizeMidWellheadMapper.class);
        QueryWrapper<SpaceOptimizeMidWellheadEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeMidWellheadEnt::getId, input.getId());
        SpaceOptimizeMidWellheadEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteSpaceOptimizeMidWellhead(XContext context, DeleteSpaceOptimizeMidWellheadInput input) {
        SpaceOptimizeMidWellheadMapper mapper = context.getBean(SpaceOptimizeMidWellheadMapper.class);
        QueryWrapper<SpaceOptimizeMidWellheadEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeMidWellheadEnt::getId, input.getId());
        SpaceOptimizeMidWellheadEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceOptimizeMidWellheadOutput> getSpaceOptimizeMidWellhead(XContext context, GetSpaceOptimizeMidWellheadInput input) {
        SpaceOptimizeMidWellheadMapper mapper = context.getBean(SpaceOptimizeMidWellheadMapper.class);
        QueryWrapper<SpaceOptimizeMidWellheadEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeMidWellheadEnt::getId, input.getId());
        SpaceOptimizeMidWellheadEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceOptimizeMidWellheadOutput output = new GetSpaceOptimizeMidWellheadOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeMidWellheadOutput> querySpaceOptimizeMidWellhead(XContext context, QuerySpaceOptimizeMidWellheadInput input) {
        SpaceOptimizeMidWellheadMapper mapper = context.getBean(SpaceOptimizeMidWellheadMapper.class);
        QueryWrapper<SpaceOptimizeMidWellheadEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(SpaceOptimizeMidWellheadEnt::getId, input.getId())
                .eq(SpaceOptimizeMidWellheadEnt::getIsDeleted, input.getIsDeleted())
                .like(SpaceOptimizeMidWellheadEnt::getCreateById, input.getCreateById())
                .like(SpaceOptimizeMidWellheadEnt::getCreateByName, input.getCreateByName())
                .eq(SpaceOptimizeMidWellheadEnt::getCreateTime, input.getCreateTime())
                .like(SpaceOptimizeMidWellheadEnt::getModifyById, input.getModifyById())
                .like(SpaceOptimizeMidWellheadEnt::getModifyByName, input.getModifyByName())
                .eq(SpaceOptimizeMidWellheadEnt::getModifyTime, input.getModifyTime())
                .like(SpaceOptimizeMidWellheadEnt::getMidPeriodId, input.getMidPeriodId())
                .like(SpaceOptimizeMidWellheadEnt::getWellheadId, input.getWellheadId())
                .like(SpaceOptimizeMidWellheadEnt::getWellNumber, input.getWellNumber());
        return XMapperHelper.query(mapper, input, queryWrapper, QuerySpaceOptimizeMidWellheadOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeMidWellheadOutput> dynamicQuerySpaceOptimizeMidWellhead(XContext context, CustomQueryInput input) {
        SpaceOptimizeMidWellheadMapper mapper = context.getBean(SpaceOptimizeMidWellheadMapper.class);
        return XMapperHelper.query(mapper, input, SpaceOptimizeMidWellheadEnt.class, QuerySpaceOptimizeMidWellheadOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceOptimizeMidWellheadViewOutput> getSpaceOptimizeMidWellheadView(XContext context, GetSpaceOptimizeMidWellheadViewInput input) {
        SpaceOptimizeMidWellheadViewMapper mapper = context.getBean(SpaceOptimizeMidWellheadViewMapper.class);
        SpaceOptimizeMidWellheadView record = new SpaceOptimizeMidWellheadView();
        XCopyUtils.copyObject(input, record);
        SpaceOptimizeMidWellheadView view = mapper.selectOne(record);
        if (view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceOptimizeMidWellheadViewOutput output = new GetSpaceOptimizeMidWellheadViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeMidWellheadViewOutput> querySpaceOptimizeMidWellheadView(XContext context, QuerySpaceOptimizeMidWellheadViewInput input) {
        SpaceOptimizeMidWellheadViewMapper mapper = context.getBean(SpaceOptimizeMidWellheadViewMapper.class);
        SpaceOptimizeMidWellheadView record = new SpaceOptimizeMidWellheadView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<SpaceOptimizeMidWellheadView> list = mapper.selectList(record);
        PageInfo<SpaceOptimizeMidWellheadView> pageInfo = new PageInfo<>(list);
        List<QuerySpaceOptimizeMidWellheadViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QuerySpaceOptimizeMidWellheadViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
