package pps.core.space.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.space.entity.SpaceOptimizeShortWellheadEnt;
import pps.core.space.entity.SpaceOptimizeShortWellheadView;
import pps.core.space.mapper.SpaceOptimizeShortWellheadMapper;
import pps.core.space.mapper.SpaceOptimizeShortWellheadViewMapper;
import pps.core.space.service.data.space_optimize_short_wellhead.*;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.data.CustomQueryInput;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class SpaceOptimizeShortWellheadService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createSpaceOptimizeShortWellhead(XContext context, CreateSpaceOptimizeShortWellheadInput input) {
        SpaceOptimizeShortWellheadMapper mapper = context.getBean(SpaceOptimizeShortWellheadMapper.class);
        SpaceOptimizeShortWellheadEnt entity = new SpaceOptimizeShortWellheadEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateSpaceOptimizeShortWellhead(XContext context, UpdateSpaceOptimizeShortWellheadInput input) {
        SpaceOptimizeShortWellheadMapper mapper = context.getBean(SpaceOptimizeShortWellheadMapper.class);
        QueryWrapper<SpaceOptimizeShortWellheadEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeShortWellheadEnt::getId, input.getId());
        SpaceOptimizeShortWellheadEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteSpaceOptimizeShortWellhead(XContext context, DeleteSpaceOptimizeShortWellheadInput input) {
        SpaceOptimizeShortWellheadMapper mapper = context.getBean(SpaceOptimizeShortWellheadMapper.class);
        QueryWrapper<SpaceOptimizeShortWellheadEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeShortWellheadEnt::getId, input.getId());
        SpaceOptimizeShortWellheadEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceOptimizeShortWellheadOutput> getSpaceOptimizeShortWellhead(XContext context, GetSpaceOptimizeShortWellheadInput input) {
        SpaceOptimizeShortWellheadMapper mapper = context.getBean(SpaceOptimizeShortWellheadMapper.class);
        QueryWrapper<SpaceOptimizeShortWellheadEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeShortWellheadEnt::getId, input.getId());
        SpaceOptimizeShortWellheadEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceOptimizeShortWellheadOutput output = new GetSpaceOptimizeShortWellheadOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeShortWellheadOutput> querySpaceOptimizeShortWellhead(XContext context, QuerySpaceOptimizeShortWellheadInput input) {
        SpaceOptimizeShortWellheadMapper mapper = context.getBean(SpaceOptimizeShortWellheadMapper.class);
        QueryWrapper<SpaceOptimizeShortWellheadEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(SpaceOptimizeShortWellheadEnt::getId, input.getId())
                .eq(SpaceOptimizeShortWellheadEnt::getIsDeleted, input.getIsDeleted())
                .like(SpaceOptimizeShortWellheadEnt::getCreateById, input.getCreateById())
                .like(SpaceOptimizeShortWellheadEnt::getCreateByName, input.getCreateByName())
                .eq(SpaceOptimizeShortWellheadEnt::getCreateTime, input.getCreateTime())
                .like(SpaceOptimizeShortWellheadEnt::getModifyById, input.getModifyById())
                .like(SpaceOptimizeShortWellheadEnt::getModifyByName, input.getModifyByName())
                .eq(SpaceOptimizeShortWellheadEnt::getModifyTime, input.getModifyTime())
                .like(SpaceOptimizeShortWellheadEnt::getShortPeriodId, input.getShortPeriodId())
                .like(SpaceOptimizeShortWellheadEnt::getWellheadId, input.getWellheadId())
                .like(SpaceOptimizeShortWellheadEnt::getWellNumber, input.getWellNumber());
        return XMapperHelper.query(mapper, input, queryWrapper, QuerySpaceOptimizeShortWellheadOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeShortWellheadOutput> dynamicQuerySpaceOptimizeShortWellhead(XContext context, CustomQueryInput input) {
        SpaceOptimizeShortWellheadMapper mapper = context.getBean(SpaceOptimizeShortWellheadMapper.class);
        return XMapperHelper.query(mapper, input, SpaceOptimizeShortWellheadEnt.class, QuerySpaceOptimizeShortWellheadOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceOptimizeShortWellheadViewOutput> getSpaceOptimizeShortWellheadView(XContext context, GetSpaceOptimizeShortWellheadViewInput input) {
        SpaceOptimizeShortWellheadViewMapper mapper = context.getBean(SpaceOptimizeShortWellheadViewMapper.class);
        SpaceOptimizeShortWellheadView record = new SpaceOptimizeShortWellheadView();
        XCopyUtils.copyObject(input, record);
        SpaceOptimizeShortWellheadView view = mapper.selectOne(record);
        if (view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceOptimizeShortWellheadViewOutput output = new GetSpaceOptimizeShortWellheadViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeShortWellheadViewOutput> querySpaceOptimizeShortWellheadView(XContext context, QuerySpaceOptimizeShortWellheadViewInput input) {
        SpaceOptimizeShortWellheadViewMapper mapper = context.getBean(SpaceOptimizeShortWellheadViewMapper.class);
        SpaceOptimizeShortWellheadView record = new SpaceOptimizeShortWellheadView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<SpaceOptimizeShortWellheadView> list = mapper.selectList(record);
        PageInfo<SpaceOptimizeShortWellheadView> pageInfo = new PageInfo<>(list);
        List<QuerySpaceOptimizeShortWellheadViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QuerySpaceOptimizeShortWellheadViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
